from http import HTTPStatus
from typing import Any, Dict, List, Optional, Union, cast

import httpx

from ...client import AuthenticatedClient, Client
from ...types import Response, UNSET
from ... import errors

from ...models.security_outpu_secret import SecurityOutpuSecret
from typing import Dict
from ...models.security_input_set import SecurityInputSet
from typing import cast



def _get_kwargs(
    *,
    body: SecurityInputSet,

) -> Dict[str, Any]:
    headers: Dict[str, Any] = {}


    

    

    _kwargs: Dict[str, Any] = {
        "method": "post",
        "url": "/security/set",
    }

    _body = body.to_dict()


    _kwargs["json"] = _body
    headers["Content-Type"] = "application/json"

    _kwargs["headers"] = headers
    return _kwargs


def _parse_response(*, client: Union[AuthenticatedClient, Client], response: httpx.Response) -> Optional[Union[Any, SecurityOutpuSecret]]:
    if response.status_code == HTTPStatus.CREATED:
        response_201 = SecurityOutpuSecret.from_dict(response.json())



        return response_201
    if response.status_code == HTTPStatus.BAD_REQUEST:
        response_400 = cast(Any, None)
        return response_400
    if response.status_code == HTTPStatus.UNAUTHORIZED:
        response_401 = cast(Any, None)
        return response_401
    if response.status_code == HTTPStatus.INTERNAL_SERVER_ERROR:
        response_500 = cast(Any, None)
        return response_500
    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(*, client: Union[AuthenticatedClient, Client], response: httpx.Response) -> Response[Union[Any, SecurityOutpuSecret]]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    *,
    client: AuthenticatedClient,
    body: SecurityInputSet,

) -> Response[Union[Any, SecurityOutpuSecret]]:
    """ Enregistre des informations de connexion (si le compte existe déjà, les jetons existants sont
    systématiquement invalidés)

    Args:
        body (SecurityInputSet): Paramètres pour créer des informations de connexion

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Union[Any, SecurityOutpuSecret]]
     """


    kwargs = _get_kwargs(
        body=body,

    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)

def sync(
    *,
    client: AuthenticatedClient,
    body: SecurityInputSet,

) -> Optional[Union[Any, SecurityOutpuSecret]]:
    """ Enregistre des informations de connexion (si le compte existe déjà, les jetons existants sont
    systématiquement invalidés)

    Args:
        body (SecurityInputSet): Paramètres pour créer des informations de connexion

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Union[Any, SecurityOutpuSecret]
     """


    return sync_detailed(
        client=client,
body=body,

    ).parsed

async def asyncio_detailed(
    *,
    client: AuthenticatedClient,
    body: SecurityInputSet,

) -> Response[Union[Any, SecurityOutpuSecret]]:
    """ Enregistre des informations de connexion (si le compte existe déjà, les jetons existants sont
    systématiquement invalidés)

    Args:
        body (SecurityInputSet): Paramètres pour créer des informations de connexion

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Union[Any, SecurityOutpuSecret]]
     """


    kwargs = _get_kwargs(
        body=body,

    )

    response = await client.get_async_httpx_client().request(
        **kwargs
    )

    return _build_response(client=client, response=response)

async def asyncio(
    *,
    client: AuthenticatedClient,
    body: SecurityInputSet,

) -> Optional[Union[Any, SecurityOutpuSecret]]:
    """ Enregistre des informations de connexion (si le compte existe déjà, les jetons existants sont
    systématiquement invalidés)

    Args:
        body (SecurityInputSet): Paramètres pour créer des informations de connexion

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Union[Any, SecurityOutpuSecret]
     """


    return (await asyncio_detailed(
        client=client,
body=body,

    )).parsed
