from http import HTTPStatus
from typing import Any, Dict, List, Optional, Union, cast

import httpx

from ...client import AuthenticatedClient, Client
from ...types import Response, UNSET
from ... import errors

from typing import Dict
from ...models.people_lite import PeopleLite
from typing import cast, List
from typing import cast
from typing import Union
from ...types import UNSET, Unset



def _get_kwargs(
    name: str,
    *,
    authorization: Union[Unset, str] = UNSET,

) -> Dict[str, Any]:
    

    

    params: Dict[str, Any] = {}

    params["authorization"] = authorization


    params = {k: v for k, v in params.items() if v is not UNSET and v is not None}


    _kwargs: Dict[str, Any] = {
        "method": "get",
        "url": "/authorizations/perimeters/{name}/users".format(name=name,),
        "params": params,
    }


    return _kwargs


def _parse_response(*, client: Union[AuthenticatedClient, Client], response: httpx.Response) -> Optional[Union[Any, List['PeopleLite']]]:
    if response.status_code == HTTPStatus.OK:
        response_200 = []
        _response_200 = response.json()
        for response_200_item_data in (_response_200):
            response_200_item = PeopleLite.from_dict(response_200_item_data)



            response_200.append(response_200_item)

        return response_200
    if response.status_code == HTTPStatus.INTERNAL_SERVER_ERROR:
        response_500 = cast(Any, None)
        return response_500
    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(*, client: Union[AuthenticatedClient, Client], response: httpx.Response) -> Response[Union[Any, List['PeopleLite']]]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    name: str,
    *,
    client: AuthenticatedClient,
    authorization: Union[Unset, str] = UNSET,

) -> Response[Union[Any, List['PeopleLite']]]:
    """ Liste les comptes ayant périmètre d'autorisations connus

    Args:
        name (str):
        authorization (Union[Unset, str]):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Union[Any, List['PeopleLite']]]
     """


    kwargs = _get_kwargs(
        name=name,
authorization=authorization,

    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)

def sync(
    name: str,
    *,
    client: AuthenticatedClient,
    authorization: Union[Unset, str] = UNSET,

) -> Optional[Union[Any, List['PeopleLite']]]:
    """ Liste les comptes ayant périmètre d'autorisations connus

    Args:
        name (str):
        authorization (Union[Unset, str]):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Union[Any, List['PeopleLite']]
     """


    return sync_detailed(
        name=name,
client=client,
authorization=authorization,

    ).parsed

async def asyncio_detailed(
    name: str,
    *,
    client: AuthenticatedClient,
    authorization: Union[Unset, str] = UNSET,

) -> Response[Union[Any, List['PeopleLite']]]:
    """ Liste les comptes ayant périmètre d'autorisations connus

    Args:
        name (str):
        authorization (Union[Unset, str]):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Union[Any, List['PeopleLite']]]
     """


    kwargs = _get_kwargs(
        name=name,
authorization=authorization,

    )

    response = await client.get_async_httpx_client().request(
        **kwargs
    )

    return _build_response(client=client, response=response)

async def asyncio(
    name: str,
    *,
    client: AuthenticatedClient,
    authorization: Union[Unset, str] = UNSET,

) -> Optional[Union[Any, List['PeopleLite']]]:
    """ Liste les comptes ayant périmètre d'autorisations connus

    Args:
        name (str):
        authorization (Union[Unset, str]):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Union[Any, List['PeopleLite']]
     """


    return (await asyncio_detailed(
        name=name,
client=client,
authorization=authorization,

    )).parsed
