from http import HTTPStatus
from typing import Any, Dict, List, Optional, Union, cast

import httpx

from ...client import AuthenticatedClient, Client
from ...types import Response, UNSET
from ... import errors

from typing import Dict
from ...models.employee import Employee
from typing import cast
from typing import cast, List



def _get_kwargs(
    *,
    pattern: str,

) -> Dict[str, Any]:
    

    

    params: Dict[str, Any] = {}

    params["pattern"] = pattern


    params = {k: v for k, v in params.items() if v is not UNSET and v is not None}


    _kwargs: Dict[str, Any] = {
        "method": "get",
        "url": "/employees",
        "params": params,
    }


    return _kwargs


def _parse_response(*, client: Union[AuthenticatedClient, Client], response: httpx.Response) -> Optional[Union[Any, List['Employee']]]:
    if response.status_code == HTTPStatus.OK:
        response_200 = []
        _response_200 = response.json()
        for response_200_item_data in (_response_200):
            response_200_item = Employee.from_dict(response_200_item_data)



            response_200.append(response_200_item)

        return response_200
    if response.status_code == HTTPStatus.UNPROCESSABLE_ENTITY:
        response_422 = cast(Any, None)
        return response_422
    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(*, client: Union[AuthenticatedClient, Client], response: httpx.Response) -> Response[Union[Any, List['Employee']]]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    *,
    client: AuthenticatedClient,
    pattern: str,

) -> Response[Union[Any, List['Employee']]]:
    """ Cherche des comptes de personnel actif selon un motif de recherche

    Args:
        pattern (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Union[Any, List['Employee']]]
     """


    kwargs = _get_kwargs(
        pattern=pattern,

    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)

def sync(
    *,
    client: AuthenticatedClient,
    pattern: str,

) -> Optional[Union[Any, List['Employee']]]:
    """ Cherche des comptes de personnel actif selon un motif de recherche

    Args:
        pattern (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Union[Any, List['Employee']]
     """


    return sync_detailed(
        client=client,
pattern=pattern,

    ).parsed

async def asyncio_detailed(
    *,
    client: AuthenticatedClient,
    pattern: str,

) -> Response[Union[Any, List['Employee']]]:
    """ Cherche des comptes de personnel actif selon un motif de recherche

    Args:
        pattern (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Union[Any, List['Employee']]]
     """


    kwargs = _get_kwargs(
        pattern=pattern,

    )

    response = await client.get_async_httpx_client().request(
        **kwargs
    )

    return _build_response(client=client, response=response)

async def asyncio(
    *,
    client: AuthenticatedClient,
    pattern: str,

) -> Optional[Union[Any, List['Employee']]]:
    """ Cherche des comptes de personnel actif selon un motif de recherche

    Args:
        pattern (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Union[Any, List['Employee']]
     """


    return (await asyncio_detailed(
        client=client,
pattern=pattern,

    )).parsed
