from http import HTTPStatus
from typing import Any, Dict, List, Optional, Union, cast

import httpx

from ...client import AuthenticatedClient, Client
from ...types import Response, UNSET
from ... import errors

from typing import Dict
from ...models.people_lite import PeopleLite
from typing import cast
from typing import Union
from ...types import UNSET, Unset



def _get_kwargs(
    id: str,
    *,
    include_all: Union[Unset, bool] = UNSET,

) -> Dict[str, Any]:
    

    

    params: Dict[str, Any] = {}

    params["includeAll"] = include_all


    params = {k: v for k, v in params.items() if v is not UNSET and v is not None}


    _kwargs: Dict[str, Any] = {
        "method": "get",
        "url": "/people/{id}".format(id=id,),
        "params": params,
    }


    return _kwargs


def _parse_response(*, client: Union[AuthenticatedClient, Client], response: httpx.Response) -> Optional[Union[Any, PeopleLite]]:
    if response.status_code == HTTPStatus.OK:
        response_200 = PeopleLite.from_dict(response.json())



        return response_200
    if response.status_code == HTTPStatus.NOT_FOUND:
        response_404 = cast(Any, None)
        return response_404
    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(*, client: Union[AuthenticatedClient, Client], response: httpx.Response) -> Response[Union[Any, PeopleLite]]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    id: str,
    *,
    client: AuthenticatedClient,
    include_all: Union[Unset, bool] = UNSET,

) -> Response[Union[Any, PeopleLite]]:
    """ Récupère les informations d'un compte

    Args:
        id (str):
        include_all (Union[Unset, bool]):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Union[Any, PeopleLite]]
     """


    kwargs = _get_kwargs(
        id=id,
include_all=include_all,

    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)

def sync(
    id: str,
    *,
    client: AuthenticatedClient,
    include_all: Union[Unset, bool] = UNSET,

) -> Optional[Union[Any, PeopleLite]]:
    """ Récupère les informations d'un compte

    Args:
        id (str):
        include_all (Union[Unset, bool]):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Union[Any, PeopleLite]
     """


    return sync_detailed(
        id=id,
client=client,
include_all=include_all,

    ).parsed

async def asyncio_detailed(
    id: str,
    *,
    client: AuthenticatedClient,
    include_all: Union[Unset, bool] = UNSET,

) -> Response[Union[Any, PeopleLite]]:
    """ Récupère les informations d'un compte

    Args:
        id (str):
        include_all (Union[Unset, bool]):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Union[Any, PeopleLite]]
     """


    kwargs = _get_kwargs(
        id=id,
include_all=include_all,

    )

    response = await client.get_async_httpx_client().request(
        **kwargs
    )

    return _build_response(client=client, response=response)

async def asyncio(
    id: str,
    *,
    client: AuthenticatedClient,
    include_all: Union[Unset, bool] = UNSET,

) -> Optional[Union[Any, PeopleLite]]:
    """ Récupère les informations d'un compte

    Args:
        id (str):
        include_all (Union[Unset, bool]):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Union[Any, PeopleLite]
     """


    return (await asyncio_detailed(
        id=id,
client=client,
include_all=include_all,

    )).parsed
