from typing import Any, Dict, Type, TypeVar, Tuple, Optional, BinaryIO, TextIO, TYPE_CHECKING

from typing import List


from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

import datetime
from typing import cast, List
from typing import cast
from ..types import UNSET, Unset
from typing import Union
from dateutil.parser import isoparse






T = TypeVar("T", bound="EmployeeInfos")


@_attrs_define
class EmployeeInfos:
    """ Description du détail d'un personnel de l'université

        Attributes:
            sources (Union[Unset, List[str]]): Source de l'information
            categories (Union[Unset, List[str]]): Catégories de l'emploi
            bap (Union[Unset, List[str]]): BAP
            socio_professional (Union[Unset, List[str]]): Catégories socioprofresionnelles
            cnu (Union[Unset, List[str]]): CNU
            memberships (Union[Unset, List[str]]): Corps de métier
            start (Union[Unset, datetime.datetime]): Début du statut
            effective (Union[Unset, datetime.datetime]): Date effective du statut
            end (Union[Unset, datetime.datetime]): Fin du statut
            disciplines (Union[Unset, List[str]]): Disciplines du second degré
            echelon (Union[Unset, str]): Echelon
            type (Union[Unset, str]): Emploi type
            family (Union[Unset, str]): Famille professionnelle
            function (Union[Unset, str]): Fonction
            grade (Union[Unset, str]): Grade
            research_organizations (Union[Unset, List[str]]): Organismes de recherche
            atos_specializations (Union[Unset, List[str]]): Spécialisations ATOS
            bap_specializations (Union[Unset, List[str]]): Spécificité BAP
            itarf_specializations (Union[Unset, List[str]]): Spécificité ITARF
            contract_types (Union[Unset, List[str]]): Types de contrat
            populations (Union[Unset, List[str]]): Types de population
            is_active (Union[Unset, bool]): Témoin d'activité des informations
     """

    sources: Union[Unset, List[str]] = UNSET
    categories: Union[Unset, List[str]] = UNSET
    bap: Union[Unset, List[str]] = UNSET
    socio_professional: Union[Unset, List[str]] = UNSET
    cnu: Union[Unset, List[str]] = UNSET
    memberships: Union[Unset, List[str]] = UNSET
    start: Union[Unset, datetime.datetime] = UNSET
    effective: Union[Unset, datetime.datetime] = UNSET
    end: Union[Unset, datetime.datetime] = UNSET
    disciplines: Union[Unset, List[str]] = UNSET
    echelon: Union[Unset, str] = UNSET
    type: Union[Unset, str] = UNSET
    family: Union[Unset, str] = UNSET
    function: Union[Unset, str] = UNSET
    grade: Union[Unset, str] = UNSET
    research_organizations: Union[Unset, List[str]] = UNSET
    atos_specializations: Union[Unset, List[str]] = UNSET
    bap_specializations: Union[Unset, List[str]] = UNSET
    itarf_specializations: Union[Unset, List[str]] = UNSET
    contract_types: Union[Unset, List[str]] = UNSET
    populations: Union[Unset, List[str]] = UNSET
    is_active: Union[Unset, bool] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)


    def to_dict(self) -> Dict[str, Any]:
        sources: Union[Unset, List[str]] = UNSET
        if not isinstance(self.sources, Unset):
            sources = self.sources





        categories: Union[Unset, List[str]] = UNSET
        if not isinstance(self.categories, Unset):
            categories = self.categories





        bap: Union[Unset, List[str]] = UNSET
        if not isinstance(self.bap, Unset):
            bap = self.bap





        socio_professional: Union[Unset, List[str]] = UNSET
        if not isinstance(self.socio_professional, Unset):
            socio_professional = self.socio_professional





        cnu: Union[Unset, List[str]] = UNSET
        if not isinstance(self.cnu, Unset):
            cnu = self.cnu





        memberships: Union[Unset, List[str]] = UNSET
        if not isinstance(self.memberships, Unset):
            memberships = self.memberships





        start: Union[Unset, str] = UNSET
        if not isinstance(self.start, Unset):
            start = self.start.isoformat()

        effective: Union[Unset, str] = UNSET
        if not isinstance(self.effective, Unset):
            effective = self.effective.isoformat()

        end: Union[Unset, str] = UNSET
        if not isinstance(self.end, Unset):
            end = self.end.isoformat()

        disciplines: Union[Unset, List[str]] = UNSET
        if not isinstance(self.disciplines, Unset):
            disciplines = self.disciplines





        echelon = self.echelon

        type = self.type

        family = self.family

        function = self.function

        grade = self.grade

        research_organizations: Union[Unset, List[str]] = UNSET
        if not isinstance(self.research_organizations, Unset):
            research_organizations = self.research_organizations





        atos_specializations: Union[Unset, List[str]] = UNSET
        if not isinstance(self.atos_specializations, Unset):
            atos_specializations = self.atos_specializations





        bap_specializations: Union[Unset, List[str]] = UNSET
        if not isinstance(self.bap_specializations, Unset):
            bap_specializations = self.bap_specializations





        itarf_specializations: Union[Unset, List[str]] = UNSET
        if not isinstance(self.itarf_specializations, Unset):
            itarf_specializations = self.itarf_specializations





        contract_types: Union[Unset, List[str]] = UNSET
        if not isinstance(self.contract_types, Unset):
            contract_types = self.contract_types





        populations: Union[Unset, List[str]] = UNSET
        if not isinstance(self.populations, Unset):
            populations = self.populations





        is_active = self.is_active


        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({
        })
        if sources is not UNSET:
            field_dict["sources"] = sources
        if categories is not UNSET:
            field_dict["categories"] = categories
        if bap is not UNSET:
            field_dict["bap"] = bap
        if socio_professional is not UNSET:
            field_dict["socioProfessional"] = socio_professional
        if cnu is not UNSET:
            field_dict["cnu"] = cnu
        if memberships is not UNSET:
            field_dict["memberships"] = memberships
        if start is not UNSET:
            field_dict["start"] = start
        if effective is not UNSET:
            field_dict["effective"] = effective
        if end is not UNSET:
            field_dict["end"] = end
        if disciplines is not UNSET:
            field_dict["disciplines"] = disciplines
        if echelon is not UNSET:
            field_dict["echelon"] = echelon
        if type is not UNSET:
            field_dict["type"] = type
        if family is not UNSET:
            field_dict["family"] = family
        if function is not UNSET:
            field_dict["function"] = function
        if grade is not UNSET:
            field_dict["grade"] = grade
        if research_organizations is not UNSET:
            field_dict["researchOrganizations"] = research_organizations
        if atos_specializations is not UNSET:
            field_dict["atosSpecializations"] = atos_specializations
        if bap_specializations is not UNSET:
            field_dict["bapSpecializations"] = bap_specializations
        if itarf_specializations is not UNSET:
            field_dict["itarfSpecializations"] = itarf_specializations
        if contract_types is not UNSET:
            field_dict["contractTypes"] = contract_types
        if populations is not UNSET:
            field_dict["populations"] = populations
        if is_active is not UNSET:
            field_dict["isActive"] = is_active

        return field_dict



    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        if not src_dict:
            return None
        d = src_dict.copy()
        sources = cast(List[str], d.pop("sources", UNSET))


        categories = cast(List[str], d.pop("categories", UNSET))


        bap = cast(List[str], d.pop("bap", UNSET))


        socio_professional = cast(List[str], d.pop("socioProfessional", UNSET))


        cnu = cast(List[str], d.pop("cnu", UNSET))


        memberships = cast(List[str], d.pop("memberships", UNSET))


        _start = d.pop("start", UNSET)
        start: Union[Unset, datetime.datetime]
        if isinstance(_start,  Unset) or _start is None:
            start = UNSET
        else:
            start = isoparse(_start)




        _effective = d.pop("effective", UNSET)
        effective: Union[Unset, datetime.datetime]
        if isinstance(_effective,  Unset) or _effective is None:
            effective = UNSET
        else:
            effective = isoparse(_effective)




        _end = d.pop("end", UNSET)
        end: Union[Unset, datetime.datetime]
        if isinstance(_end,  Unset) or _end is None:
            end = UNSET
        else:
            end = isoparse(_end)




        disciplines = cast(List[str], d.pop("disciplines", UNSET))


        echelon = d.pop("echelon", UNSET)

        type = d.pop("type", UNSET)

        family = d.pop("family", UNSET)

        function = d.pop("function", UNSET)

        grade = d.pop("grade", UNSET)

        research_organizations = cast(List[str], d.pop("researchOrganizations", UNSET))


        atos_specializations = cast(List[str], d.pop("atosSpecializations", UNSET))


        bap_specializations = cast(List[str], d.pop("bapSpecializations", UNSET))


        itarf_specializations = cast(List[str], d.pop("itarfSpecializations", UNSET))


        contract_types = cast(List[str], d.pop("contractTypes", UNSET))


        populations = cast(List[str], d.pop("populations", UNSET))


        is_active = d.pop("isActive", UNSET)

        employee_infos = cls(
            sources=sources,
            categories=categories,
            bap=bap,
            socio_professional=socio_professional,
            cnu=cnu,
            memberships=memberships,
            start=start,
            effective=effective,
            end=end,
            disciplines=disciplines,
            echelon=echelon,
            type=type,
            family=family,
            function=function,
            grade=grade,
            research_organizations=research_organizations,
            atos_specializations=atos_specializations,
            bap_specializations=bap_specializations,
            itarf_specializations=itarf_specializations,
            contract_types=contract_types,
            populations=populations,
            is_active=is_active,
        )

        employee_infos.additional_properties = d
        return employee_infos

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
