from typing import Any, Dict, Type, TypeVar, Tuple, Optional, BinaryIO, TextIO, TYPE_CHECKING

from typing import List


from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

from typing import Union
from ..types import UNSET, Unset






T = TypeVar("T", bound="EmployeeRole")


@_attrs_define
class EmployeeRole:
    """ Description d'un rôle contextuel

        Attributes:
            code (Union[Unset, str]): Code du rôle générique
            entity_type (Union[Unset, str]): Type de l'entité
            entity_code (Union[Unset, str]): Code de l'entité
            entity_name (Union[Unset, str]): Nom de l'entité
     """

    code: Union[Unset, str] = UNSET
    entity_type: Union[Unset, str] = UNSET
    entity_code: Union[Unset, str] = UNSET
    entity_name: Union[Unset, str] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)


    def to_dict(self) -> Dict[str, Any]:
        code = self.code

        entity_type = self.entity_type

        entity_code = self.entity_code

        entity_name = self.entity_name


        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({
        })
        if code is not UNSET:
            field_dict["code"] = code
        if entity_type is not UNSET:
            field_dict["entityType"] = entity_type
        if entity_code is not UNSET:
            field_dict["entityCode"] = entity_code
        if entity_name is not UNSET:
            field_dict["entityName"] = entity_name

        return field_dict



    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        if not src_dict:
            return None
        d = src_dict.copy()
        code = d.pop("code", UNSET)

        entity_type = d.pop("entityType", UNSET)

        entity_code = d.pop("entityCode", UNSET)

        entity_name = d.pop("entityName", UNSET)

        employee_role = cls(
            code=code,
            entity_type=entity_type,
            entity_code=entity_code,
            entity_name=entity_name,
        )

        employee_role.additional_properties = d
        return employee_role

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
