from typing import Any, Dict, Type, TypeVar, Tuple, Optional, BinaryIO, TextIO, TYPE_CHECKING

from typing import List


from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

from typing import Union
from typing import cast, List
from ..models.input_authorization_operation import InputAuthorizationOperation
from ..types import UNSET, Unset






T = TypeVar("T", bound="InputAuthorization")


@_attrs_define
class InputAuthorization:
    """ Paramètres pour mettre à jour les autorisations d'un compte

        Attributes:
            operation (Union[Unset, InputAuthorizationOperation]): Type d'opération à effectuer
            authorizations (Union[Unset, List[str]]): Valeurs à ajouter ou à supprimer
     """

    operation: Union[Unset, InputAuthorizationOperation] = UNSET
    authorizations: Union[Unset, List[str]] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)


    def to_dict(self) -> Dict[str, Any]:
        operation: Union[Unset, str] = UNSET
        if not isinstance(self.operation, Unset):
            operation = self.operation.value


        authorizations: Union[Unset, List[str]] = UNSET
        if not isinstance(self.authorizations, Unset):
            authorizations = self.authorizations






        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({
        })
        if operation is not UNSET:
            field_dict["operation"] = operation
        if authorizations is not UNSET:
            field_dict["authorizations"] = authorizations

        return field_dict



    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        if not src_dict:
            return None
        d = src_dict.copy()
        _operation = d.pop("operation", UNSET)
        operation: Union[Unset, InputAuthorizationOperation]
        if isinstance(_operation,  Unset) or _operation is None:
            operation = UNSET
        else:
            operation = InputAuthorizationOperation(_operation)




        authorizations = cast(List[str], d.pop("authorizations", UNSET))


        input_authorization = cls(
            operation=operation,
            authorizations=authorizations,
        )

        input_authorization.additional_properties = d
        return input_authorization

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
